// UnitSms.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "UnitSms.h"
#include <process.h>
#include <afxtempl.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SMS_NONE 0
#define SMS_TEXT 1
#define SMS_BINARY 2

typedef struct {
   unsigned int  Type; // SMS_PDU / SMS_TEXT
   unsigned int  Length; 
   unsigned char Phonenumber[32];
   unsigned char Message[161]; // ASCIIZ if Type==SMS_TEXT, else binary data
} tdefSMS;

CList<tdefSMS*,tdefSMS*> qSMSFromTarget;
CList<tdefSMS*,tdefSMS*> qSMS;

static void SendSMS( unsigned char type, char* phone, int length, unsigned char* buffer ) {
  tdefSMS* SMS = new tdefSMS;

  SMS->Type=type;
  strcpy_s( (char*)SMS->Phonenumber, sizeof(SMS->Phonenumber), phone ); 

  if (type==SMS_TEXT) {
	  strcpy_s((char*)SMS->Message,sizeof(SMS->Message), (char*)buffer); 
    SMS->Length=strlen((char*)buffer);
  } else {
    memcpy((char*)SMS->Message, (void*)buffer, length); 
    SMS->Length=length;
  }

  qSMSFromTarget.AddTail(SMS);
}

//---------------------------------------------------------------
#pragma optimize("g", off) // Disable global optimization

static void th( void* arg )
{
   char buffer[512];
   int rc, smstype, numbytes;

   for (;;) {
      rc = rmonReceiveSMS(hCon, &smstype, &numbytes, buffer);
      if( rc == rmonOK ) {

         if( ((CUnitSms*)arg)->m_autoshow )
           ((CUnitSms*)arg)->ShowWindow(SW_SHOW);

         if( smstype == RMONSMS_TEXT ) {
            CTime t = CTime::GetCurrentTime();
            CString s = t.Format( "%X" );

//            ((CUnitSms*)arg)->m_outgoing.InsertString( -1, s + " ->[9999]: " + buffer, ::GetSysColor(COLOR_WINDOWTEXT));
            ((CUnitSms*)arg)->m_outgoing.InsertString( -1, s + " ->[9999]: " + buffer );
            // If last item already selected, go select the new "last" item
            int nCount = ((CUnitSms*)arg)->m_outgoing.GetCount();
            if( nCount == ((CUnitSms*)arg)->m_outgoing.GetCurSel() + 2 ) { 
               if( nCount > 0 )
                  ((CUnitSms*)arg)->m_outgoing.SetCurSel( nCount - 1 );
            }

            SendSMS(SMS_TEXT, "9999", strlen(buffer), (unsigned char*)buffer);
         } else if (smstype==RMONSMS_BINARY) {
            CTime t = CTime::GetCurrentTime();
            CString s = t.Format( "%X" );
            CString str;
            str.Format("PDU %s ->[9999, Len=%i]:",s, numbytes);

            CString x;
            for( int i = 0; i < numbytes; i++ ) {
               x.Format("%02X ",(unsigned char)buffer[i]);
               str += x;
            }

//             ((CUnitSms*)arg)->m_outgoing.InsertString(-1,str, RGB(255, 128, 0));
            ((CUnitSms*)arg)->m_outgoing.InsertString( -1, str );
            // If last item already selected, go select the new "last" item
            int nCount = ((CUnitSms*)arg)->m_outgoing.GetCount();
            if( nCount == ((CUnitSms*)arg)->m_outgoing.GetCurSel() + 2 ) { 
               if( nCount > 0 )
                  ((CUnitSms*)arg)->m_outgoing.SetCurSel( nCount - 1 );
            }

            SendSMS( SMS_BINARY, "9999", numbytes, (unsigned char*)buffer );
         }
      } else {
         Sleep(50);
      }
   }
}

#pragma optimize("", on)

/////////////////////////////////////////////////////////////////////////////
// CUnitSms dialog


CUnitSms::CUnitSms(CWnd* pParent /*=NULL*/)
	: CDialog(CUnitSms::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUnitSms)
	m_editincomming = _T("");
	m_autoshow		= FALSE;
	//}}AFX_DATA_INIT
}


void CUnitSms::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnitSms)
	DDX_Control(pDX, IDC_CLEARINCOMING, m_ctrclearincomming);
	DDX_Control(pDX, IDC_CLEARCOMBO, m_ctrclearcombo);
	DDX_Control(pDX, IDOK, m_ctrok);
	DDX_Control(pDX, IDC_SMSCOMBO, m_ctrsmscombo);
	DDX_Control(pDX, IDC_SENDSMS, m_ctrsend);
	DDX_Control(pDX, IDC_OUTGOING, m_outgoing);
	DDX_Text(pDX, IDC_EDITINCOMMING, m_editincomming);
	DDV_MaxChars(pDX, m_editincomming, 160);
	DDX_Check(pDX, IDC_AUTOSHOW, m_autoshow);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUnitSms, CDialog)
	//{{AFX_MSG_MAP(CUnitSms)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_AUTOSHOW, OnAutoshow)
	ON_BN_CLICKED(IDC_CLEARINCOMING, OnClearincoming)
	ON_BN_CLICKED(IDC_CLEARCOMBO, OnClearcombo)
	ON_BN_CLICKED(IDC_SENDSMS, OnSendsms)
	ON_CBN_SELENDOK(IDC_SMSCOMBO, OnSelendokSmscombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Helpers for saving/restoring window state

static TCHAR BASED_CODE szSection[] = _T("UnitSms");
static TCHAR BASED_CODE szWindowPos[] = _T("WindowPos");
static TCHAR szFormat[] = _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d");

static BOOL PASCAL NEAR ReadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	CString strBuffer = AfxGetApp()->GetProfileString(szSection, szWindowPos);
	if (strBuffer.IsEmpty())
		return FALSE;

	WINDOWPLACEMENT wp;
	int nRead = sscanf_s(strBuffer, szFormat,
		&wp.flags, &wp.showCmd,
		&wp.ptMinPosition.x, &wp.ptMinPosition.y,
		&wp.ptMaxPosition.x, &wp.ptMaxPosition.y,
		&wp.rcNormalPosition.left, &wp.rcNormalPosition.top,
		&wp.rcNormalPosition.right, &wp.rcNormalPosition.bottom);

	if (nRead != 10)
		return FALSE;

	wp.length = sizeof wp;
	*pwp = wp;
	return TRUE;
}

static void PASCAL NEAR WriteWindowPlacement(LPWINDOWPLACEMENT pwp)
	// write a window placement to settings section of app's ini file
{
	TCHAR szBuffer[sizeof("-32767")*8 + sizeof("65535")*2];

	wsprintf(szBuffer, szFormat,
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(szSection, szWindowPos, szBuffer);
}

/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// Create / Destroy
/////////////////////////////////////////////////////////////////////////////

BOOL CUnitSms::OnInitDialog() 
{
   // Default
   CDialog::OnInitDialog();

   // Windows Position
   WINDOWPLACEMENT wp;
   if( ReadWindowPlacement(&wp) ) {
      CRect rc;
      GetWindowRect(&rc);
      if( ((rc.bottom-rc.top) & 0xFFFC) == ((wp.rcNormalPosition.bottom - wp.rcNormalPosition.top) & 0xFFFC) &&
          ((rc.right-rc.left) & 0xFFFC) == ((wp.rcNormalPosition.right - wp.rcNormalPosition.left) & 0xFFFC)) {
         wp.showCmd = false;
   	   SetWindowPlacement(&wp);
      }
   }

   // Get all strings in the combobox, and save'em
   CString str, strList;
   strList = AfxGetApp()->GetProfileString( "UnitSms", "COMBO" );
   // If something in list...
   if( !strList.IsEmpty() ) {
      // Find how manu entries exists in the list, format is "AA||BB||CC||DD||"
      int i=strList.Replace("||", "||"); // This gives a count for the number of "||" sequences
      while (i) {
         str = strList.Left(strList.Find("||", 0)); // Extract the string
         strList.Delete(0, strList.Find("||", 0)); // Kill the string
         strList.Delete(0,2); // Kill the "||"
         m_ctrsmscombo.AddString(str);
         i--;
      }
   }
   m_autoshow=AfxGetApp()->GetProfileInt( "UnitSms", "AUTOSHOW", 0 );

   UpdateData(false);

   // Make sure that the HScrollbar can scroll to 128 chars
   CSize   sz;
   CDC*    pDC = m_outgoing.GetDC();
   sz = pDC->GetTextExtent("A", 300);
   m_outgoing.ReleaseDC(pDC);
   m_outgoing.SetHorizontalExtent(sz.cx);
//   m_outgoing.SetFont("MS Sans Serif");

   _beginthread(th, 0, this);

   // Completed
   return TRUE;
}

void CUnitSms::OnDestroy() 
{
   UpdateData(true);

   // Get all strings in the combobox, and save'em
   CString str, strList;
   for( int i = 0; i < m_ctrsmscombo.GetCount(); i++ ) {
      m_ctrsmscombo.GetLBText( i, str );
      if( !str.IsEmpty() ) {
         strList += str;
         strList += "||";
      }
   } 
   AfxGetApp()->WriteProfileString( "UnitSms", "COMBO", strList );

   // before it is destroyed, save the position of the window
   WINDOWPLACEMENT wp;
   wp.length = sizeof wp;
   if( GetWindowPlacement(&wp) )
   {
      wp.flags = 0;
      if( IsZoomed() )
         wp.flags |= WPF_RESTORETOMAXIMIZED;
      // and write it to the .INI file
      WriteWindowPlacement(&wp);
   }

   // Default
   CDialog::OnDestroy();
}

/////////////////////////////////////////////////////////////////////////////
// Failsafe
/////////////////////////////////////////////////////////////////////////////

void CUnitSms::OnOK() 
{
   ShowWindow(SW_HIDE);
}

void CUnitSms::OnCancel() 
{
   ShowWindow(SW_HIDE);
}

/////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////

void CUnitSms::OnAutoshow() 
{
   UpdateData(true);	
   AfxGetApp()->WriteProfileInt( "UnitSms", "AUTOSHOW", m_autoshow );
}

void CUnitSms::OnClearincoming() 
{
   m_outgoing.ResetContent();
}

void CUnitSms::OnClearcombo() 
{
   m_ctrsmscombo.ResetContent();	
}

void CUnitSms::OnSelendokSmscombo() 
{
   CString str;
   UpdateData(true);
   int index=m_ctrsmscombo.GetCurSel();
   m_ctrsmscombo.GetLBText(index, str);
   m_editincomming=str;
   UpdateData(false);
}

void CUnitSms::OnSendsms() 
{
   int rc;

   UpdateData(true);

   // Delete entry if already there
   m_ctrsmscombo.DeleteString( m_ctrsmscombo.FindStringExact( -1, m_editincomming ) );
   // And insert at top
   m_ctrsmscombo.InsertString( 0, m_editincomming );

   BeginWaitCursor();

   m_ctrsend.EnableWindow(false);
   m_ctrok.EnableWindow(false);
   m_ctrsmscombo.EnableWindow(false);
   m_outgoing.EnableWindow(false);
   m_ctrclearcombo.EnableWindow(false);
   m_ctrclearincomming.EnableWindow(false);

   rc=rmonSendSMS(hCon, RMONSMS_TEXT, m_editincomming.GetLength()+1, m_editincomming);
   if(rc) {
      AfxMessageBox("Error in communicating with RTCU unit");
   }

   m_ctrsend.EnableWindow(true);
   m_ctrok.EnableWindow(true);
   m_ctrsmscombo.EnableWindow(true);
   m_outgoing.EnableWindow(true);
   m_ctrclearcombo.EnableWindow(true);
   m_ctrclearincomming.EnableWindow(true);
   EndWaitCursor();
}
